import React, { useEffect, useState } from 'react';

import { get } from '../utils/request';
//TODO adjust config usage
import config from '../utils/config';

import Map from '../components/map-array';

export default function MapLGroup(){

    const [array, setArray] = useState([]);

    /*fetch array in a JavaScript function*/
    const fetch = async () => {
        try {
		/*TODO handle errors: https://www.valentinog.com/blog/await-react/*/
	    const address = config.ADDRESS + 'nwr[shop=second_hand](area)->.shops;nwr[second_hand=yes](area)->.secondHands;(.shops;.secondHands;);' + config.OUT;
	    console.log("Fetch:fetch(): address: " + address);
	    const res = await get(address);
	    console.log("Fetch:fetch(): res.length: "+res.elements.length);
	    setArray((array) => res.elements);
        } catch (err) {
	    console.error('err.message: ' + err.message);
	    setArray((array) => []);
        }
    };

    useEffect(() => {
	/*effect goes here*/
	fetch();
	/*use an empty dependency array to ensure the hook is running only once*/
	/*TODO study dependency array: https://reactjs.org/docs/hooks-effect.html*/
    }, []);


    if ( array !== undefined && array !== null && array.length > 0 ) {
	/*return a React element*/
	return (
            <>
		<p>MapLGroup</p>
		<Map
		    array={array}
		/>
            </>
	);
    }else{
	return (
            <>
	    <p>MapLGroup</p>
	    <p>Loading...</p>
            </>
	);
    }
}
